#ifndef MPID_CHANNEL_DEF
#define MPID_CHANNEL_DEF

#include <stdio.h>
#include <sys/root.h>
#define MPID_MyWorldRank GET_ROOT()->ProcRoot->MyProcID
#define MPID_WorldSize   GET_ROOT()->ProcRoot->nProcs

#define MPID_USE_SEND_BLOCK

#define MPID_RecvAnyControl( pkt, size, from ) MPID_PARIX_RecvAnyControl(pkt, size,from)
#define MPID_RecvFromChannel( buf, size, channel ) MPID_PARIX_RecvFromChannel( buf, size, channel )
#define MPID_ControlMsgAvail( ) MPID_PARIX_ControlMsgAvail( )
#define MPID_SendControl( pkt, size, channel ) MPID_PARIX_SendControl( pkt, size, channel )
#if defined(MPID_USE_SEND_BLOCK) && ! defined(MPID_SendControlBlock)
/* 
   SendControlBlock allows the send to wait until the message is 
   received (but does NOT require it).  This can simplify some buffer 
   handling.
 */
#define MPID_SendControlBlock( pkt, size, channel ) MPID_PARIX_SendControlBlock( pkt, size, channel ) 

#endif
/* If we did not define SendControlBlock, make it the same as SendControl */
#if !defined(MPID_SendControlBlock)
#define MPID_SendControlBlock(pkt,size,channel) \
      MPID_SendControl(pkt,size,channel)
#endif

#ifdef MPID_USE_SEND_BLOCK
#define MPID_SENDCONTROL(mpid_send_handle,pkt,len,dest)  \
if (mpid_send_handle->is_non_blocking) {\
    MPID_SendControl( pkt, len, dest );}\
else {\
    MPID_SendControlBlock( pkt, len, dest );}
#else
#define MPID_SENDCONTROL(mpid_send_handle,pkt,len,dest) \
MPID_SendControl( pkt, len, dest )
#endif


#define MPID_SendChannel( buf, size, channel ) MPID_PARIX_SendChannel( buf, size, channel )
#define MPID_ISendChannel( buf, size, channel, sid) MPID_PARIX_ISendChannel( buf, size, channel, sid )

#endif
